Combination Sum IV中兩種JAVA動態規劃解法的不同

leetcode題目:https://leetcode.com/problems/combination-sum-iv/#/description

Given an integer array with all positive numbers and no duplicates,
find the number of possible combinations that add up to a positive
integer target.

Example:

nums = [1, 2, 3] target = 4

The possible combination ways are: (1, 1, 1, 1) (1, 1, 2) (1, 2, 1)
(1, 3) (2, 1, 1) (2, 2) (3, 1)

Note that different sequences are counted as different combinations.

solution 1 : (correct one)

public class Solution {

    public int combinationSum4(int[] nums, int target) {
        // 在遞歸過程中,如果狀態集是有限的,我們可以採用動態規劃的方法,把每個狀態的結果記錄下來,以減少計算量。
        int[] dp = new int[target + 1];
        dp[0] = 1;
        for (int i = 1; i < dp.length; i++) {        //  outer loop is  to  traversal  dp array 
            for (int j = 0; j < nums.length; j++) {    // inner loop is to  traversal  nums array  
                if (i - nums[j] >= 0) {
                    dp[i] += dp[i - nums[j]];
                }
            }
        }
        return dp[target];
    }

}

solution 2:(wrong one )

public class Solution {

    public int combinationSum4(int[] nums, int target) {
        int [] dp = new int[target + 1];

        dp[0] = 1;
        for (int i = 0; i < nums.length; i++) {        //  outer loop is  to  traversal  nums array and nums array should be ASC ordered
            for (int j = nums[i]; j <= target; j++) {   //  inner loop is to  traversal  dp array  
                dp[j] += dp[j - nums[i]];
            }
        }
        return dp[target];
    }

}

when give a testcase:

nums = [1, 2, 3]
target = 4

solution 1 got the answer 7:
The possible combination ways are:
(1, 1, 1, 1)
(1, 1, 2)
(1, 2, 1)
(1, 3)
(2, 1, 1)
(2, 2)
(3, 1)
i wanna say this is Permutations not combination.

solution 2 give the answer 4, Obviously, delete the same combination from the above possible Permutations, eg (1, 1, 2) (1, 2, 1) (2, 1, 1) (1, 3) (3, 1), the answer is 4.

so, solution 1 could get the Permutation Sum, and solution 2 could get the Combination Sum. this is because the count order of dp and nums is different.

發表評論
所有評論
還沒有人評論,想成為第一個評論的人麼? 請在上方評論欄輸入並且點擊發布.
相關文章